#include "pkt_all.h"
#include <stdlib.h>

uint32 PktMain::count = 0;

enum { DLT_NULL=0, DLT_PPP=9, DLT_FDDI=10, DLT_RAW=12};
enum { HDR_NULL=2, HDR_FDDI=13 };

AnlPkt * PktMain::parse_pkt(const uchar * pdata, uint32 psize, char cut) {
  if (! psize) { // Chybny paket...
    return NULL;
  }
  switch ( ltype ) {
    case DLT_EN10MB:
       return new EthFrame(pdata, psize, cut);
    case DLT_RAW: // Tohle jeste vime jiste
       return new IP_Pkt(pdata, psize, cut);
    // Jinde ocekavame jen IP pakety, protoze typ uz z frame nezjistime
    // Odsud je to neodzousena magie (tcpdump to stejne vetsinou ulozi
    //                                jako ethernetovy ramec)
    
    case DLT_FDDI:
       // 2 6-byte adresy + dalsi informace (1 byte na zac ?+ neco?)
       return new EthFrame(pdata-HDR_EN10MB+HDR_FDDI,
			   psize+HDR_EN10MB-HDR_FDDI, cut);
    case DLT_PPP:
    case DLT_NULL:
       // Jen typ ramce ?
       return new EthFrame(pdata+HDR_NULL, psize+HDR_NULL, cut,
						   (pdata[0] << 8) + pdata[1]);
    default:
       g_printf("Typ vrstvy %x je mi zcela neznamy, koncim...\n", ltype);
       exit(FILEERR);
  }
  return NULL; // Sem by se nemel dostat - jen kvuli BCC
}
