#include <conio.h>
#include <stdio.h>
#include <stdlib.h>
#include <ctype.h>
#include <dos.h>
#include <sys/timeb.h>
#include <time.h>
#include <alloc.h>

#include "pktfunc.h"
#include "hdr_type.h"
#include "anl_pkt.h"
#include "ethdump.h"
extern "C"{
#include "capt.h"
}


extern fhdr def_fhdr;
extern long timezone;
unsigned int buffLen = MAX_SNAP;
unsigned char *bufferData;  
unsigned char buffer[MAX_SNAP];  

unsigned char *bufferDyn;
unsigned char *bufferDynZac;
unsigned int freeBytes;

unsigned int frameLength;
unsigned int maxLength=DEF_SNAP;
unsigned int bufferFull = 0;
unsigned int mode = 6;
unsigned int ref=0;
unsigned int posl_hl=0;
unsigned int mutex=0;
unsigned int pckt_count=0;
unsigned int const pkthdr_len=sizeof(pkthdr);
int longinfo=LONG_INFO;
int useMem=TRUE;
double delayTime = DEF_DELAY * CLK_TCK;
char *filename = NULL;
char *inFilename = NULL;
#ifdef SIMULATE
  char *simFilename = "simul.dat";
#endif
FILE *output;

unsigned long ip_addr_sour;
unsigned long ip_addr_dest;
unsigned short mac_addr_sour[3];
unsigned short mac_addr_dest[3];
unsigned int compareAddr = 0;
unsigned int compareProt = OTHER_PROT|OTHER_IP_PROT|TCP_PROT|UDP_PROT;


int intVector, handle;
extern "C" {
 void pkInt ();
}


int setMode(int newMode) {
  return setRcvMode(intVector, handle, newMode); 
}


int odregistrujInt() {
  return releaseType(intVector, handle);
}

int zaregistrujInt() {
  unsigned int version, type;
  unsigned char drv_class, number, functionality;
  unsigned char localAddress[6];
  int f;
  if (driverInfo(intVector, 0xffff, &version, &drv_class,
                  &type, &number, &functionality) == -1) {
    printf("Nastala chyba pri ziskavani informaci o driveru(%3d)\n", 
          getLastError());
    exit(1);
  }
  printf("Driver nalezen na vectoru 0x%x\n",intVector);
  if (getAddress(intVector,0,(char*) localAddress,6)!=-1){ 
    printf("Lokalni adresa: ");
    for (f=0; f<6; f++) {
      printf("%02x",localAddress[f]);
    }
    printf("\n");
  }
        
  handle = accessType(intVector, drv_class, type, number, NULL, 0, pkInt);

  if (handle==-1) {
    printf("Nastala chyba pri snaze zaregistrovat zadost o pakety u"
              " driveru (%3d)\n", getLastError());
    getch();
    exit(1);
  }

  return 0;
}


void receivedFrameMem(){
  int pktrec_len;
  int i;
  struct date d;
  struct timeb tu;
  struct time t;
  pkthdr *head = (pkthdr *)bufferDyn;
  WORD ethType =*((WORD*)(buffer+12));
  ethType=SWAP16(ethType);
  
  ftime(&tu);
  (head->tstamp).time=tu.time-timezone-((tu.dstflag)?3600:0);
  (head->tstamp).usec=(uint32)tu.millitm * 1000;
  (head->caplen)=(maxLength<frameLength)?maxLength:frameLength;
  (head->len)=frameLength;
  tu.time=(head->tstamp).time+((tu.dstflag)?3600:0)+timezone;
  tu.millitm=(head->tstamp).usec/1000;
  unixtodos(tu.time,&d,&t);
  memcpy(bufferData,buffer,head->caplen);  
  
  if(posl_hl<ref) {
    printf("\n!!! Nestihnuto paketu: %d\n",ref-posl_hl);
    posl_hl=ref;
  }
  if(longinfo>NO_INFO){
  printf("\n# %d (%.2d:%.2d:%.2d,%.3d)  Delka: %d\n",
          pckt_count,t.ti_hour,t.ti_min,t.ti_sec,
          (int)((head->tstamp).usec/1000),(int)(head->len));
  }
  if(longinfo>MIN_INFO){
  printf("ETH: %.2x:%.2x:%.2x:%.2x:%.2x:%.2x -> "
         "%.2x:%.2x:%.2x:%.2x:%.2x:%.2x (%s)\n",
          *((BYTE *)(buffer+6)),*((BYTE *)(buffer+7)),
          *((BYTE *)(buffer+8)),*((BYTE *)(buffer+9)),
          *((BYTE *)(buffer+10)),*((BYTE *)(buffer+11)),
          *((BYTE *)buffer),*((BYTE *)(buffer+1)),
          *((BYTE *)(buffer+2)),*((BYTE *)(buffer+3)),
          *((BYTE *)(buffer+4)),*((BYTE *)(buffer+5)),
          get_eth_prot((unsigned int)ethType));
  }
  if(ethType == IP_TYPE && longinfo ==LONG_INFO){
    printf("IP: %.3d.%.3d.%.3d.%.3d -> %.3d.%.3d.%.3d.%.3d (%s)\n",
         *((BYTE *)(buffer+26)),*((BYTE *)(buffer+27)),
         *((BYTE *)(buffer+28)),*((BYTE *)(buffer+29)), 
         *((BYTE *)(buffer+30)),*((BYTE *)(buffer+31)),
         *((BYTE *)(buffer+32)),*((BYTE *)(buffer+33)),
         protocolType(*((BYTE *)(buffer+23))));
  }
  pktrec_len=(head->caplen) + pkthdr_len;
  bufferData+=pktrec_len;
  bufferDyn+=pktrec_len;
  freeBytes-=pktrec_len; 
} 


void receivedFrame() {
  struct date d;
  struct timeb tu;
  struct time t;
  pkthdr head;
  pktrec rec;
  WORD ethType =*((WORD*)(buffer+12));
  ethType=SWAP16(ethType);
  
  ftime(&tu);
  unixtodos(tu.time,&d,&t);
  head.tstamp.time=tu.time-timezone-((tu.dstflag)?3600:0);
  head.tstamp.usec=(uint32)tu.millitm * 1000;
  head.caplen=(maxLength<frameLength)?maxLength:frameLength;
  head.len=frameLength;
  
  rec.h=&head;
  rec.data=buffer;
  pkt_write(output, &rec);
  
  if(posl_hl<ref) {
     printf("\n!!! Nestihnuto paketu: %d\n",ref-posl_hl);
     posl_hl=ref;
   }
  if(longinfo>NO_INFO){
  printf("\n# %d (%.2d:%.2d:%.2d,%.3d)  Delka: %d\n",
          pckt_count,t.ti_hour,t.ti_min,t.ti_sec,(int)(tu.millitm/1000),
          frameLength);
  }
  if(longinfo>MIN_INFO){
  printf("ETH: %.2x:%.2x:%.2x:%.2x:%.2x:%.2x -> "
         "%.2x:%.2x:%.2x:%.2x:%.2x:%.2x (%s)\n",
          *((BYTE *)(buffer+6)),*((BYTE *)(buffer+7)),*((BYTE *)(buffer+8)),
          *((BYTE *)(buffer+9)),*((BYTE *)(buffer+10)),*((BYTE *)(buffer+11)),
          (BYTE)*buffer,*((BYTE *)(buffer+1)),*((BYTE *)(buffer+2)),
          *((BYTE *)(buffer+3)),*((BYTE *)(buffer+4)),*((BYTE *)(buffer+5)),
          get_eth_prot((unsigned int)ethType));
  }
  if(ethType == IP_TYPE && longinfo ==LONG_INFO){
    printf("IP: %.3d.%.3d.%.3d.%.3d -> %.3d.%.3d.%.3d.%.3d (%s)\n",
         *((BYTE *)(buffer+26)),*((BYTE *)(buffer+27)),
         *((BYTE *)(buffer+28)),*((BYTE *)(buffer+29)), 
         *((BYTE *)(buffer+30)),*((BYTE *)(buffer+31)),
         *((BYTE *)(buffer+32)),*((BYTE *)(buffer+33)),
         protocolType(*((BYTE *)(buffer+23))));
  }        
}


int testProtocol(char *buf){
  int actTyp;
  WORD ethType =*((WORD*)(buf+12));
  if(ethType!=IP_PROT_SWAPPED){
    return ((compareProt&OTHER_PROT)==0)?FALSE:TRUE;
  }
  if(*((BYTE *)(buf+23)) == TCPIP){
    actTyp=TCP_PROT;
  }
  else if(*((BYTE *)(buf+23)) == UDPIP){
    actTyp=UDP_PROT;
  }
  else {
    actTyp=OTHER_IP_PROT;
  }
  return ((compareProt&actTyp)==0)?FALSE:TRUE;
}

int testAddress(char *buf){
  int i;
  if((compareAddr&IP_ADDR_SOUR)!=0){
    if(ip_addr_sour!=*((unsigned long *)(buf +26))){
      return FALSE;
    }
  }
  if((compareAddr&IP_ADDR_DEST)!=0){
    if(ip_addr_dest!=*((unsigned long *)(buf +30))){
      return FALSE;
    }
  }
  if((compareAddr&MAC_ADDR_SOUR)!=0){
    if(mac_addr_sour[0]!=*((unsigned short *)(buf +6)) || 
        mac_addr_sour[1]!=*((unsigned short *)(buf +8)) ||
        mac_addr_sour[2]!=*((unsigned short *)(buf +10))){
      return FALSE;
    }
  }
  if((compareAddr&MAC_ADDR_DEST)!=0){
    if(mac_addr_dest[0]!=*((unsigned short *)(buf)) || 
        mac_addr_dest[1]!=*((unsigned short *)(buf +2)) ||
        mac_addr_dest[2]!=*((unsigned short *)(buf +4))){
      return FALSE;
    }
  }
  return TRUE;
}



int delayShow(){
  char c;
  time_t start = clock();
  while(clock() < (start+delayTime)){
    if(kbhit()){
      c=getch();
      switch(c){
        case '+':
          delayTime*=(1+DELAY_CHANGE);
          break;
        case  '-':
          delayTime*=(1-DELAY_CHANGE);
          break;
        case  ESC:
          return FALSE;
        case  ENTER:
          return TRUE;
        case 'd': 
        case 'D':
          delayTime = DEF_DELAY * CLK_TCK;
          break;
        case '0':
          delayTime=0;
          break;
        case 'p':
        case 'P':
          getch();
          break;
      }
    }
  }
  return TRUE;
}




void showFromFile(){
  FILE *input;
  fhdr *head = NULL;
  pktrec *pkt;
  AnlPkt * p;
  int good;
  
  if(filename!=NULL){
    output=pkt_wr_open(filename,&def_fhdr,MAX_SNAP);
  }
  input=pkt_rd_open(inFilename, &head);
  
  while ( (pkt = pkt_read(input)) != 0 ) {
    good=FALSE;
    if(pkt->h->caplen > maxLength){
      pkt->h->caplen = maxLength;
    }
    if(testProtocol(pkt->data)){
      if(compareAddr!=0){
        if(testAddress(pkt->data)){
          good=TRUE; 
        }
      }
      else {
        good=TRUE; 
      }
    }
    if(good){
      if(filename!=NULL){
        pkt_write(output, pkt);
      }
      p=AnlPkt::parse_pkt(pkt->data, pkt->h);
      if ( p->get_types() & (T_IP|T_ARP)) {
        p->show(T_ALL ^ T_OTHERS ^ T_DATA ^ T_FRAME ^ S_DATE);
      } else {
        p->header(T_ALL ^ S_DATE /*^ S_USEC*/);
      }
      g_putc('\n');
      delete p;
    }
    freepkt(pkt); // Nesmime zapomenout !
    if(good){
      if(!delayShow()){
        break;
      }
    }
  }
  fclose(input);
  if(filename!=NULL){
    fclose(output);
  }
}


int processPackets(){
  char c;
  int q;
  
  if(filename!=NULL && !useMem){ 
    output=pkt_wr_open(filename,&def_fhdr,MAX_SNAP);
  }
  if(!processPacketsHelp()){
    if(odregistrujInt()==-1){
      fprintf(stderr,"Nepodarilo se odregistrovet zadost o pakety!!!");
    }
    return FALSE;
  }

  zaregistrujInt();
  
  setMode(mode);
  printf("Byl nastaven mod: %d\n",getRcvMode(intVector,handle));
  printf("\nOcekavam pakety...\n\n");
  #ifdef SIMULATE
    FILE *simFile;
    fhdr *head = NULL;
    simFile=pkt_rd_open(simFilename,&head);
  #endif  

  c=0;  
  while(TRUE){
    if(c == ESC || c==ENTER) {
        bufferFull = 1;
        if(odregistrujInt()==-1){
          fprintf(stderr,"Nepodarilo se odregistrovet zadost o pakety!!!");
        }
        if(ref>0){
          printf("Nepodarilo se zpracovat paketu: %d. Sitovy provoz je prilis"
                          " velky.\n",ref);
        }
        if(filename!=NULL){ 
          fclose(output);
        }
        if(c==ESC) return FALSE;
        else return TRUE;
    }

    #ifdef SIMULATE
      randomize();
      pktrec *packetFromFile=NULL;
    #endif
    while (!kbhit()) {
      if(useMem && freeBytes<MAX_SNAP){
        printf("\n\nPamet je plna!!!\n\n");
        break;
      }
      #ifdef SIMULATE
        if (packetFromFile!=NULL){
          freepkt(packetFromFile);
        }
        packetFromFile= pkt_read(simFile);
        if(packetFromFile!=NULL){
            for (q=0; q<packetFromFile->h->caplen; q++) 
                   buffer[q]=(packetFromFile->data)[q];
            frameLength =packetFromFile->h->caplen;
            bufferFull = 1;
        }
        delay(random(MAX_SIMUL_DELAY));
      #endif
      if (bufferFull==1) {
        if(testProtocol(buffer)){
          if(compareAddr!=0){
            if(testAddress(buffer)){
              pckt_count++;
              if(useMem){
                receivedFrameMem(); 
              }
              else {
                receivedFrame(); 
              }
            }
          }
          else {
            pckt_count++;
            if(useMem){
              receivedFrameMem(); 
            }
            else {
              receivedFrame(); 
            }
          } //if(compareAddr!=0)
        } //if(testProtocol(bufferData))
        bufferFull=0;
      } //if(bufferFull == 1)
    } //while(!kbhit())
    if(useMem && freeBytes<MAX_SNAP){
      c=ENTER;
    }
    else{
      c = toupper(getch());
    }
  } //while(TRUE)
}

void saveFromMem() {
  pktrec *pkt;
  int i;
  char *b = bufferDynZac;
  
  output=pkt_wr_open(filename,&def_fhdr,MAX_SNAP);
  for(i=0;i<pckt_count;i++){
    pkt->h=(pkthdr *)b;
    pkt->data=(b+pkthdr_len);
    pkt_write(output,pkt); 
    b+=(pkthdr_len+(pkt->h->caplen));
  }
  fclose(output);
}

void showMemPackets() {
  pktrec *pkt;
  AnlPkt * p;
  int i;
  char *b = bufferDynZac;

  for(i=0;i<pckt_count;i++){
    pkt->h=(pkthdr *)b;
    pkt->data=(b+pkthdr_len);
    p=AnlPkt::parse_pkt(pkt->data, pkt->h);
    if ( p->get_types() & (T_IP|T_ARP)) {
      p->show(T_ALL ^ T_OTHERS ^ T_DATA ^ T_FRAME ^ S_DATE);
    } else {
      p->header(T_ALL ^ S_DATE /*^ S_USEC*/);
    }
    g_putc('\n');
    delete p;
    if(!delayShow()){
      break;
    }
    b+=(pkthdr_len+(pkt->h->caplen));
  }
}

void showPackets() {
  pktrec *pkt;
  fhdr * hdr = NULL;
  FILE * f;
  AnlPkt * p;
  
  f=pkt_rd_open(filename, &hdr);
  while ( (pkt = pkt_read(f)) != 0 ) {
    p=AnlPkt::parse_pkt(pkt->data, pkt->h);
    if ( p->get_types() & (T_IP|T_ARP)) {
      p->show(T_ALL ^ T_OTHERS ^ T_DATA ^ T_FRAME ^ S_DATE);
    } else {
      p->header(T_ALL ^ S_DATE /*^ S_USEC*/);
    }
    freepkt(pkt); // Nesmime zapomenout !
    g_putc('\n');
    delete p;
    if(!delayShow()){
      break;
    }
  }
  fclose(f);
}



void main(int argc, char **argv) {
  int i;

  clrscr();

  for(i=1;i<argc;i++){
    if(argv[i][0]=='-'){
      switch(argv[i][1]){
        case OUT_FILE_PREP: 
            if(argv[i][2]!='\0'){
              filename = (argv[i]+2);
            }
            else {
              printUsage();
              exit(-1);
            }
            break;
        case IN_FILE_PREP: 
            if(argv[i][2]!='\0'){
              inFilename = (argv[i]+2);
            }
            else {
              printUsage();
              exit(-1);
            }
            break;
#ifdef SIMULATE
        case SIN_FILE_PREP: 
            if(argv[i][2]!='\0'){
              simFilename = (argv[i]+2);
            }
            else {
              printUsage();
              exit(-1);
            }
            break;
#endif
        case LENGTH_PREP:
            if(argv[i][2]!='\0'){
              if((maxLength = atoi(argv[i]+2))!=0){
                if(maxLength < MIN_SNAP){
                  fprintf(stderr,"Packet length must be at least %d",
                          MIN_SNAP);
                  exit(-1);
                }
                else if(maxLength > MAX_SNAP){
                  fprintf(stderr,"Packet length must be less or equal %d",
                            MAX_SNAP);
                  exit(-1);
                }
              }
              else {
                printUsage();
                exit(-1);
              }
            }
            else {
              printUsage();
              exit(-1);
            }
            break;
	case HELP_PREP:
	    printUsage();
	    exit(0);
	    break;
        case SOURCE_PREP:
            if(argv[i][2]!='\0'){
              if(!parseMacAddress(argv[i]+2,
                    (unsigned char*)mac_addr_sour)){
                if(!parseIpAddress(argv[i]+2,&ip_addr_sour)){
                      fprintf(stderr,"Spatny format zdrojove adresy\n");
                   exit(-1);
                }
                else {
                  compareAddr |= IP_ADDR_SOUR;
                }
              }
              else {
                compareAddr |= MAC_ADDR_SOUR;
              }
            }
            else {
              printUsage();
              exit(-1);
            }
            break;
        case DEST_PREP:
            if(argv[i][2]!='\0'){
              if(!parseMacAddress(argv[i]+2,
                   (unsigned char*)mac_addr_dest)){
                if(!parseIpAddress(argv[i]+2,&ip_addr_dest)){
                  fprintf(stderr,"Spatny format zdrojove adresy\n");
                  exit(-1);
                }
                else {
                  compareAddr |= IP_ADDR_DEST;
                }
              }
              else {
                compareAddr |= MAC_ADDR_DEST;
              }
            }
            else {
              printUsage();
              exit(-1);
            } //if(argv[i][2]!='\0')
            break;
        case PROT_PREP:
            if(argv[i][2]!='\0'&&argv[i][3]=='\0'){
              switch(toupper(argv[i][2])){
                case TCP_PROT_PREP: 
                   compareProt=TCP_PROT;
                   break;
                case UDP_PROT_PREP:
                   compareProt=UDP_PROT;
                   break;
                case TCP_UDP_PREP:
                   compareProt=TCP_PROT|UDP_PROT;
                   break;
                case ALL_IP_PREP: 
                   compareProt=TCP_PROT|UDP_PROT|OTHER_IP_PROT;
                   break;
                case ALL_PROT_PREP: 
                   compareProt=TCP_PROT|UDP_PROT|OTHER_IP_PROT|OTHER_PROT;
                   break;
                default: 
                   fprintf(stderr, "Nepodporovany protokol");
                   exit(-1);
              } //switch(argv[i][2])
            }
            else {
              printUsage();
              exit(-1);
            }//if(argv[i][2]!='\0'&&argv[i][3]=='\0')
            break;
        case INFO_PREP:
            if(argv[i][2]!='\0'&&argv[i][3]=='\0'){
              switch(toupper(argv[i][2])){
                case NO_INFO_PREP: 
                   longinfo=NO_INFO;
                   break;
                case MIN_INFO_PREP:
                   longinfo=MIN_INFO;
                   break;
                case SHORT_INFO_PREP:
                   longinfo=SHORT_INFO;
                   break;
                case LONG_INFO_PREP:
                   longinfo=LONG_INFO;
                   break;
                default: 
                   fprintf(stderr, "Tento typ vypisu neni podprovan");
                   exit(-1);
              } //switch(argv[i][2])
            }
            else {
              printUsage();
              exit(-1);
            } //if(argv[i][2]!='\0'&&argv[i][3]=='\0')
            break;
        case NO_MEM_PREP:
           useMem=FALSE;
           break;
        case MODE_PREP:
           if(argv[i][2]!='\0'){
             if((mode = atoi(argv[i]+2))!=0){
               switch(mode){
                 case 2:
                 case 3:
                 case 5:
                 case 6:
                    break;
                 default: 
                    fprintf(stderr, "Tento mod neni podporovan");
                    exit(-1);
               }
             }
             else {
               printUsage();
               exit(-1);
             } //if((mode = atoi(argv[i]+2))!=0)
           }
           else {
             printUsage();
             exit(-1);
           } //if(argv[i][2]!='\0')
           break;
        default: 
           fprintf(stderr,"Neznamy prepinac %s\n",argv[i]);
           exit(-1);
           break;
      } //switch(argv[i][1])               
    }
    else {
      fprintf(stderr,"Neznamy parametr %s\n",argv[i]);
      exit(-1);    
    } //if(argv[i][0]=='-')
  } //for(i=1;i<argc;i++)
  if((compareAddr & (IP_ADDR_SOUR | IP_ADDR_DEST)) != NULL){
    compareProt&=~OTHER_PROT;
  }
  if(inFilename!=NULL){
    if(delayHelp()){
      showFromFile();
    } else {
      exit(0);
    }
  } 
  else {
    if(filename==NULL && !useMem){
      filename=DEF_FILENAME;
    }
    intVector = findPacketDriver();
    if (intVector == -1) {
      printf("Paketovy driver nenalezen\n");
      exit(1);
    }
    if(useMem){
      freeBytes=coreleft()-MIN_MEM;
      if(freeBytes<MAX_SNAP){
        fprintf(stderr,"Nedostatek pameti pro beh programu.\n");
        exit(-1);
      }
      bufferDynZac = (char *)malloc(freeBytes);
      bufferData = bufferDynZac+pkthdr_len;
      bufferDyn = bufferDynZac;
    }
    else {
      bufferDynZac = NULL;
    }
    if(bufferDynZac==NULL && useMem){
      fprintf(stderr,"Nepodarilo se alokovat pamet\n");
      exit(-1);
    }
    if(processPackets()){
      if(delayHelp()){
        if(useMem){
          showMemPackets();
        }
        else{
          showPackets();
        }
      }
    }
    if(filename!=NULL && useMem){
      saveFromMem();
    }
    if(bufferDynZac != NULL){
      free(bufferDynZac);
    }
  }
}
