#ifndef __HDR_TYPE_H
#define __HDR_TYPE_H
#include "capt.h"

typedef union {
  struct {
    ushort offset : 13;
    ushort flags : 3;
  } fo;
  ushort rep;
} IP_flg_off_t;

typedef struct {
  uchar ihl:4, ver:4; /* Od nejnizsich bitu */
  uchar tos;
  ushort t_len;       /* Swapped */
  ushort ident;       /* Swapped */
  IP_flg_off_t flg_off;  /* Swapped */
  uchar t_to_live;
  uchar protocol;
  ushort chksum;      /* Swapped */
  uchar src [4];
  uchar dest [4];
  /* Options - TBD*/
  /* Padding na 4 byte */
} IP_hdr;

typedef struct { 
  ushort s_port, d_port;  /* Zdrojovy a cilovy port  */
  ushort len;             /* Delka UDP paketu        */
  ushort chksum;          /* Kontrolni soucet        */
} UDP_hdr;


typedef union {
  struct {
    ushort flags:6, res:6, d_off:4;    /* Vlajky, ..., offset dat       */
  } fo;
  ushort rep;
} TCP_flg_off_t;

typedef struct {
  ushort s_port, d_port;               /* Zdrojovy a cilovy port        */
  uint32 seqNo, ackNo;                 /* Sekvencni cislo a c. akceptu  */
  TCP_flg_off_t flg_off;               /* Vlajky, ..., offset dat       */
  ushort window;                       /* Sirka okna                    */
  ushort chksum;                       /* Kontrolni soucet (celeho)     */
  ushort urgent_ptr;                   /* Urgent pointer ?              */
  /* Options, padding*/
} TCP_hdr;

typedef struct {
  ushort ident;
  ushort seqNo;
} ICMP_info;

typedef union {
  ICMP_info inf;
  uchar pointer;
  uchar gate [4];
} ICMP_data1;

typedef union {
  IP_hdr ip_hdr;
  ushort timestamp[3];
  char data [];
} ICMP_data2;

typedef struct {
  uchar type;
  uchar code;
  ushort chksum;
  ICMP_data1 d1;
  ICMP_data1 d2;
} ICMP_hdr;

typedef struct {
   ushort h_type, l_type; /* Typ HW a log. adres */
   uchar h_len, l_len;    /* delka tehoz v byte  */
   ushort opcode;         /* kod operace         */
   uchar adr[];           /* adresy, poradi sender (h,l), target(h,l) */
} ARP_hdr;

#endif /* __HDR_HYPE_H */
