#include "icmp_pkt.h"
void ICMP_Pkt::header(ushort flags, char recursive) {
  if ( hdr && (flags & T_ICMP)) {
    g_putc(' ');
    switch (hdr->type) {
      case E_RQST: g_puts("Echo - poz.");
		   break;
      case E_RPLY: g_puts("Echo - odp.");
		   break;
      case DST_U:  g_puts("Nedosaz. cil");
		   break;
      case SRC_Q:  g_puts("Zpomalit zdroj"); 
		   break;
      case REDIR:  g_puts("Presmerovano");
		   break;
      case T_EXCEED:g_puts("Cas vyprsel");
		   break;
      case PARAM: g_puts("Chyba hlavicky");
		   break;
      case T_RQST: g_puts("Timestamp - poz.");
		   break;
      case T_RPLY: g_puts("Timestamp - odp.");
		   break;
      case I_RQST: g_puts("Informace - poz.");
		   break;
      case I_RPLY: g_puts("Informace - odp.");
		   break;
    }
  }
  if (recursive && next) {
    next->header(flags);
  }
}

void ICMP_Pkt::show(ushort flags) {
  if ( hdr && (flags & T_ICMP)) {
     g_puts("ICMP:");
     header(flags, FALSE);
     switch ( hdr->type ){
       case E_RQST:
       case E_RPLY:
       case I_RQST:
       case I_RPLY:
       case T_RQST:
       case T_RPLY:
                   g_printf("  ID: %hu  Seq# %hu",
                            SWAP16(hdr->d1.inf.ident),
                            hdr->d1.inf.seqNo         );
                   break;
       case DST_U:
                   g_puts(" Pricina: ");
                   switch ( hdr->code ) {
                     case 0: g_puts("nedostupna sit");
                             break;
                     case 1: g_puts("nedostupny uzel");
                             break;
                     case 2: g_puts("nevhodny protokol");
                             break;
                     case 3: g_puts("uzavreny port");
                             break;
                     case 4: g_puts("nefrag. + musi frag.");
                             break;
                     case 5: g_puts("source route");
                             break;
                     default: g_puts("neznama");
                   }
                   break;
       case REDIR:  
                   g_puts(" Na: ");
                   switch ( hdr->code ) {
                     case 0: g_puts("sit");
                             break;
                     case 1: g_puts("uzel");
                             break;
                     case 2: g_puts("sit a typ sluzby");
                             break;
                     case 3: g_puts("uzel a typ sluzby");
                             break;
                     default: g_puts("neznama");
                   }
                   g_printf(" Pres: %u:%u:%u:%u", hdr->d1.gate[0], 
                                                  hdr->d1.gate[1], 
                                                  hdr->d1.gate[2],
                                                  hdr->d1.gate[3]);
                   break;
       case T_EXCEED: 
                   if (hdr->code == 1) {
                     g_puts("(pri spojovani frag.)");
                   }
                   break;
       case PARAM: 
                   if (hdr->code == 0) {
                     g_printf("Na pozici: %hu", hdr->d1.pointer);
                   }
                   break;
     }
     g_printf("  CHK: 0x%04hX", hdr->chksum);
     g_putc('\n');
   }
   if (next) {
     next->show(flags);
   }
}
