#ifndef __ICMP_PKT
#define __ICMP_PKT
#  include  "anl_pkt.h"
#  include  "gen_pkt.h"

class ICMP_Pkt : public AnlPkt {

protected:
    ICMP_hdr * hdr;
    enum { ADDRSIZ=2 }; // C. portu
    enum {
      E_RPLY=0, DST_U=3, SRC_Q=4, REDIR=5, E_RQST=8, T_EXCEED=11, PARAM=12,
      T_RQST=13, T_RPLY=14, I_RQST=15, I_RPLY=16
    };
    // Vlastni metody

    void swap_hdr() {
      if (!hdr) { return; }
      hdr->chksum = SWAP16(hdr->chksum);
    }

    virtual AnlPkt * parse_pkt(const uchar * pdata, uint32 psize, char cut) {
      if ( psize >= sizeof(ICMP_hdr) ) {
        hdr = (ICMP_hdr *) new char[psize];
        memcpy(hdr, pdata, psize);
        swap_hdr();
      }
      return NULL;
    }

public:
    // Konstruktory
    ICMP_Pkt(const uchar * pktdata, const uint32 psize, char cut) {
      hdr = NULL;
      next=parse_pkt(pktdata, psize, cut);
    }

    // Destruktor
    virtual ~ICMP_Pkt() {
	chk_mem("ICMP_Pkt->del 0x%hX\r\n", get_types());
	if (hdr) {
	  delete hdr;
	}
     }

    // Virtualni metody
    virtual void header(ushort flags, char recursive=TRUE);
    virtual void show(ushort flags);
    virtual ushort get_types() {
      return ((next)?(next->get_types()):0) | T_ICMP;
    }

};


#endif /* IP_PKT */
