#ifndef __IP_PKT
#define __IP_PKT
#  include  "anl_pkt.h"

class IP_Pkt : public AdrPkt {

protected:
    static char * Speeds [];
    IP_hdr * hdr;
    enum {ADDRSIZ=4};
    // Vlastni metody
    virtual AnlPkt * parse_pkt(const uchar * pdata, uint32 psize, char cut);

    void swap_hdr() { // Prehozeni nespravne nactenych polozek hlavicky
      if (!hdr) { return; }
      hdr->t_len = SWAP16(hdr->t_len);
      hdr->chksum = SWAP16(hdr->chksum);
      hdr->ident = SWAP16(hdr->ident);
      hdr->flg_off.rep = SWAP16(hdr->flg_off.rep);
    }

    virtual void show_addr(uchar * adr, int size = ADDRSIZ);

public:
    // Konstruktory
    IP_Pkt(const uchar * pktdata, const uint32 psize, char cut) {
      hdr = NULL;
      next=parse_pkt(pktdata, psize, cut);
    }

    // Destruktor
    virtual ~IP_Pkt() {
	chk_mem("IP_Pkt->del 0x%hX\r\n", get_types());
	if (hdr) {
	  delete hdr;
	}
     }

    // Virtualni metody
    virtual void show_prot();

    virtual void show_a(uchar kind) {
      if (!hdr) { return; }
      if ( kind == SRC ) {
	show_addr(hdr->dest);
      } else if ( kind == DST ) {
	show_addr(hdr->src);
      }
    }

    virtual void show(ushort flags);
    virtual void header(ushort flags, char recursive=TRUE);

    virtual ushort get_types() {
      return ((next)?(next->get_types()):0) | T_IP;
    }

};

#endif /* IP_PKT */
