/* Service Library for an Packet Driver Demonstration Program */
/*							  1995 Petr Grygarek							  */
/*  portions of code from Internet resources, by Phil Karn    */

#include <stdio.h>
#include <dos.h>
#include <string.h>
#include "pktfunc.h"

static BYTE lastError;

// The following functions act as call gates to assembly language
// packet driver routines

//.............................................................................
int setRcvMode(int intno, int handle, int mode) {
/*
AH, 20
BX, handle
CX, mode

error: carry set
DH - error code
*/
	union REGS regs;
//	struct SREGS sregs;
//	segread(&sregs);

	regs.h.ah = 20;
	regs.x.bx = handle;
	regs.x.cx = mode;
	int86(intno,&regs,&regs);
//	int86x(intno,&regs,&regs,&sregs);
	if(regs.x.cflag) { lastError = regs.h.dh; return -1; }
	else return 0;
}

 /*Zjisteni modu prijimani paketu*/
 int getRcvMode(int intno, int handle){
	union REGS regs;
	struct SREGS sregs;
	
	segread(&sregs);
	
	regs.h.ah = GET_RCV_MODE;
	regs.x.bx = handle;
//	int86(intno,&regs,&regs);
	int86x(intno,&regs,&regs,&sregs);
	if(regs.x.cflag) {lastError = regs.h.dh; return -1; }
	return regs.x.ax;
  }
 /*Zjisteni modu prijimani paketu*/
 int resetInterface(int intno, int handle){
	union REGS regs;
	struct SREGS sregs;
	
	segread(&sregs);
	
	regs.h.ah = 7;
	regs.x.bx = handle;
//	int86(intno,&regs,&regs);
	int86x(intno,&regs,&regs,&sregs);
	if(regs.x.cflag) {lastError = regs.h.dh; return -1; }
	return 1;
  }

//.............................................................................

int accessType(int intno, BYTE if_class, WORD if_type, BYTE if_number,
		char* type, unsigned typelen, void (*receiver)())
{
	REGS regs;
	SREGS sregs;

	segread(&sregs);
	regs.h.ah = ACCESS_TYPE;	/* Access_type() function */
	regs.h.al = if_class;		/* Class */
	regs.x.bx = if_type;		   /* Type */
	regs.h.dl = if_number;		/* Number */

	sregs.ds = FP_SEG(type);	/* Packet type template */
	regs.x.si = FP_OFF(type);
	regs.x.cx = typelen;		/* Length of type */

	sregs.es = FP_SEG(receiver);	/* Address of receive handler */
	regs.x.di = FP_OFF(receiver);

	int86x(intno,&regs,&regs,&sregs);

	if(regs.x.cflag){
		lastError = regs.h.dh;
		return -1;
	} else return regs.x.ax;
}

//.............................................................................

int releaseType(int intno, int handle)
{
	union REGS regs;

	regs.h.ah = RELEASE_TYPE;
	regs.x.bx = handle;
	int86(intno,&regs,&regs);
	if(regs.x.cflag){ lastError = regs.h.dh; return -1; }
	 else	return 0;
}

//.............................................................................

int sendPkt(int intno, char* buffer, unsigned length)
{
	union REGS regs;
	struct SREGS sregs;

	segread(&sregs);
	sregs.ds = FP_SEG(buffer); /* DS:SI - in specification */
	sregs.es = FP_SEG(buffer); /* for buggy univation pkt driver - CDY */
	regs.x.si = FP_OFF(buffer);
	regs.x.cx = length;
	regs.h.ah = SEND_PKT;
	int86x(intno,&regs,&regs,&sregs);
	if(regs.x.cflag){	lastError = regs.h.dh; return -1; }
	 else	return 0;
}

//.............................................................................

int driverInfo(int intno, int handle, WORD *version, BYTE *dclass,
		WORD *type, BYTE* number, BYTE* functionality)
{
	union REGS regs;

	regs.h.ah = DRIVER_INFO;
	regs.x.bx = handle;

	regs.h.al = 0xff;
	int86(intno,&regs,&regs);
	if(regs.x.cflag){ lastError = regs.h.dh; return -1; }
	if (version) *version = regs.x.bx;
	if (dclass) *dclass = regs.h.ch;
	if (type) *type = regs.x.dx;
	if (number) *number = regs.h.cl;
	if (functionality) *functionality = regs.h.al;
	return 0;
}

//.............................................................................

param* getParameters(int intno)
{
	union REGS regs;
	struct SREGS sregs;

	regs.h.ah = GET_PARAMETERS;
	int86x(intno,&regs,&regs,&sregs);
	if(regs.x.cflag){ lastError = regs.h.dh; return NULL; }
	return (param*) MK_FP(sregs.es, regs.x.di);
}

//.............................................................................

getAddress(int intno,int handle,char* buf,int len)
{
	union REGS regs;
	struct SREGS sregs;

	segread(&sregs);
	regs.h.ah = GET_ADDRESS;
	sregs.es = FP_SEG(buf);
	regs.x.di = FP_OFF(buf);
	regs.x.cx = len;
	regs.x.bx = handle;
	int86x(intno,&regs,&regs,&sregs);
	if(regs.x.cflag) {lastError = regs.h.dh; return -1; }
	return 0;
}

//.............................................................................

/* find an interrupt vector where the packet driver is installed */
int findPacketDriver(int fromVector)
 {
  char far* ptr;
  for (int v=fromVector; v<0x80; v++)
	{
	 ptr= (char*) getvect(v);
	 if (strcmpi(ptr+3,"PKT DRVR")==0) return v;
	}
  return -1;
 }

//.............................................................................

int getLastError() { return lastError; }

//.............................................................................
