#include "capt.h"
/* 
 // Zajimave porty primo pojmenuji 
 enum { ftp=21, telnet=23, http=80, pop3=110, imap2=143, imap3=220, 
       ldap=389, login=513, shell=514};
*/

typedef struct {
   ushort portNo;
   const char * name;
   ushort protos;
   uchar inter_f, inter_to; /* Interresting 0-never, 1-sometimes, 3-always */
} portinfo;

const char * x11 = "X11";

const portinfo ports[] = {
    {   7, "echo", T_TCP|T_UDP, NEVER, NEVER},
    {   9, "discard", T_TCP|T_UDP, NEVER, NEVER},
    {  19, "chargen", T_TCP|T_UDP, NEVER, NEVER},
    {  20, "ftp-data", T_TCP, NEVER, NEVER},
    {  21, "ftp", T_TCP, ALWAYS, ALWAYS},
    {  22, "ssh", T_TCP|T_UDP, NEVER, NEVER},
    {  23, "telnet", T_TCP, ALWAYS, ALWAYS},
    {  25, "smtp", T_TCP, SOMETIMES, SOMETIMES},
    {  37, "time", T_TCP|T_UDP, NEVER, NEVER},
    {  42, "nameserv", T_TCP|T_UDP, NEVER, NEVER},
    {  43, "whois", T_TCP, NEVER, NEVER},
    {  53, "dns", T_TCP|T_UDP, NEVER, NEVER},
    {  67, "bootp-srv", T_TCP|T_UDP, NEVER, NEVER},
    {  68, "bootp-kl", T_TCP|T_UDP, NEVER, NEVER},
    {  69, "tftp", T_TCP|T_UDP, NEVER, NEVER},
    {  70, "gopher", T_TCP|T_UDP, NEVER, NEVER},
    {  79, "finger", T_TCP|T_UDP, NEVER, NEVER},
    {  80, "http", T_TCP|T_UDP, SOMETIMES, ALWAYS},
    {  88, "kerberos", T_TCP|T_UDP, NEVER, NEVER},
    { 109, "pop2", T_TCP|T_UDP, SOMETIMES, SOMETIMES},
    { 110, "pop3", T_TCP|T_UDP, SOMETIMES, ALWAYS},
    { 111, "rpc", T_TCP|T_UDP, NEVER, NEVER},
    { 113, "auth", T_TCP|T_UDP, NEVER, NEVER},
    { 115, "sftp", T_TCP|T_UDP, NEVER, NEVER},
    { 119, "nntp", T_TCP|T_UDP, NEVER, NEVER},
    { 123, "ntp", T_TCP|T_UDP, NEVER, NEVER},
    { 143, "imap2", T_TCP|T_UDP, SOMETIMES, SOMETIMES},
    { 161, "snmp", T_TCP|T_UDP, NEVER, NEVER},
    { 194, "irc", T_TCP|T_UDP, NEVER, NEVER},
    { 220, "imap3", T_TCP|T_UDP, SOMETIMES, SOMETIMES},
    { 389, "ldap", T_TCP|T_UDP, SOMETIMES, ALWAYS},
    { 443, "https", T_TCP|T_UDP, NEVER, NEVER},
    { 513, "login", T_TCP, SOMETIMES, SOMETIMES},
    { 513, "who", T_UDP, NEVER, NEVER},
    { 514, "shell", T_TCP, NEVER, NEVER},
    { 514, "syslog", T_TCP, NEVER, NEVER},
    { 515, "lpd", T_TCP|T_UDP, NEVER, NEVER},
    { 517, "talk", T_TCP|T_UDP, NEVER, NEVER},
    { 518, "ntalk", T_TCP|T_UDP, NEVER, NEVER},
    { 540, "uucp", T_TCP|T_UDP, NEVER, NEVER},
    { 565, "whoami", T_TCP|T_UDP, NEVER, NEVER},
    { 636, "ldap-ssl", T_TCP, NEVER, NEVER},
    {   0, NULL, 0 } /* Koncovy zaznam */
};       
  
const char * getport(ushort portNo, ushort proto) {
  int i=0;
  while ( ports[i].portNo != 0 ) {
     if ( ports[i].portNo == portNo && (ports[i].protos & proto)) {
        return ports[i].name;
     }
     i++;
  }
  if ( (proto & T_TCP) && portNo >= 6000 && portNo < 6010 ) {
     return x11;
  }
  return NULL; /* Pokud nevime */
}

uchar interresting(ushort portNo, ushort proto, uchar kind) {
 int i=0;
  while ( ports[i].portNo != 0 ) {
     if ( ports[i].portNo == portNo && (ports[i].protos & proto)) {
        uchar val=NEVER;
        if (kind & SRC) { val=ports[i].inter_f; }
        if (kind & DST) { val|=ports[i].inter_to; }
        return val;
     }
     i++;
  }
  return NEVER; /* Pokud nevime */
}   
