#include <ctype.h>
#include <stdio.h>
#include "ethdump.h"
#include "capt.h"
char *protocolType(int num){
  switch(num){
      case 0: return "Reserved"; 
      case 1: return "ICMP"; 
      case 3: return "Gateway"; 
      case 4: return "CMCC GMM"; 
      case 5: return "ST"; 
      case 6: return "TCP"; 
      case 7: return "UCL"; 
      case 9: return "Secure"; 
      case 10: return "BBN RCC Mon."; 
      case 11: return "NVP"; 
      case 12: return "PUP"; 
      case 13: return "Pluribus"; 
      case 14: return "Telenet"; 
      case 15: return "XNET"; 
      case 16: return "Chaos"; 
      case 17: return "UDP"; 
      case 18: return "Multiplexing"; 
      case 19: return "DCN"; 
      case 20: return "TAC Mon."; 
      case 63: return "local net."; 
      case 64: return "SATNET EXPAK"; 
      case 65: return "MIT Subnet"; 
      case 69: return "SATNET Mon."; 
      case 71: return "IPCU"; 
      case 76: return "SATNET Mon."; 
      case 78: return "WIDEBAND Mon."; 
      case 79: return "WIDEBAND EXPAK"; 
      case 255: return "Reserved";
      default: return "???";
   }
}

char *all_eth_types(unsigned int pnum){
  if (pnum <= 0x05DC) return "IEEE802.3 Length Field";
  if (pnum>= 0x0101 && pnum <= 0x01FF) return "Experimental";
  if (pnum == 0x0200) return "XEROX PUP";
  if (pnum == 0x0201) return "PUP Addr Trans";
  if (pnum == 0x0400) return "Nixdorf";
  if (pnum == 0x0600) return "XEROX NS IDP";
  if (pnum == 0x0660) return "DLOG";
  if (pnum == 0x0661) return "DLOG";
  if (pnum == 0x0800) return "Internet IP (IPv4)";
  if (pnum == 0x0801) return "X.75 Internet";
  if (pnum == 0x0802) return "NBS Internet";
  if (pnum == 0x0803) return "ECMA Internet";
  if (pnum == 0x0804) return "Chaosnet";
  if (pnum == 0x0805) return "X.25 Level 3";
  if (pnum == 0x0806) return "ARP";
  if (pnum == 0x0807) return "XNS Compatability";
  if (pnum == 0x0808) return "Frame Relay ARP";
  if (pnum == 0x081C) return "Symbolics Private";
  if (pnum>= 0x0888 && pnum <= 0x088A) return "Xyplex";
  if (pnum == 0x0900) return "Ungermann-Bass net debugr";
  if (pnum == 0x0A00) return "Xerox IEEE802.3 PUP";
  if (pnum == 0x0A01) return "PUP Addr Trans";
  if (pnum == 0x0BAD) return "Banyan VINES";
  if (pnum == 0x0BAE) return "VINES Loopback";
  if (pnum == 0x0BAF) return "VINES Echo";
  if (pnum == 0x1000) return "Berkeley Trailer nego";
  if (pnum>= 0x1001 && pnum <= 0x100F) return "Berkeley Trailer encap/IP";
  if (pnum == 0x1600) return "Valid Systems";
  if (pnum == 0x4242) return "PCS Basic Block Protocol";
  if (pnum == 0x5208) return "BBN Simnet";
  if (pnum == 0x6000) return "DEC Unassigned (Exp.)";
  if (pnum == 0x6001) return "DEC MOP Dump/Load";
  if (pnum == 0x6002) return "DEC MOP Remote Console";
  if (pnum == 0x6003) return "DEC DECNET Phase IV Route";
  if (pnum == 0x6004) return "DEC LAT";
  if (pnum == 0x6005) return "DEC Diagnostic Protocol";
  if (pnum == 0x6006) return "DEC Customer Protocol";
  if (pnum == 0x6007) return "DEC LAVC, SCA";
  if (pnum>= 0x6008 && pnum <= 0x6009) return "DEC Unassigned";
  if (pnum>= 0x6010 && pnum <= 0x6014) return "Com Corporation";
  if (pnum == 0x6558) return "Trans Ether Bridging";
  if (pnum == 0x6559) return "Raw Frame Relay";
  if (pnum == 0x7000) return "Ungermann-Bass download";
  if (pnum == 0x7002) return "Ungermann-Bass dia/loop";
  if (pnum>= 0x7020 && pnum <= 0x7029) return "LRT";
  if (pnum == 0x7030) return "Proteon";
  if (pnum == 0x7034) return "Cabletron";
  if (pnum == 0x8003) return "Cronus VLN";
  if (pnum == 0x8004) return "Cronus Direct";
  if (pnum == 0x8005) return "HP Probe";
  if (pnum == 0x8006) return "Nestar";
  if (pnum == 0x8008) return "AT&T";
  if (pnum == 0x8010) return "Excelan";
  if (pnum == 0x8013) return "	SGI diagnostics";
  if (pnum == 0x8014) return "SGI network games";
  if (pnum == 0x8015) return "SGI reserved";
  if (pnum == 0x8016) return "	SGI bounce server";
  if (pnum == 0x8019) return "Apollo Domain";
  if (pnum == 0x802E) return "Tymshare";
  if (pnum == 0x802F) return "Tigan, Inc.";
  if (pnum == 0x8035) return "Reverse ARP";
  if (pnum == 0x8036) return "Aeonic Systems";
  if (pnum == 0x8038) return "DEC LANBridge";
  if (pnum>= 0x8039 && pnum <= 0x803C) return "DEC Unassigned";
  if (pnum == 0x803D) return "DEC Ethernet Encryption";
  if (pnum == 0x803E) return "DEC Unassigned";
  if (pnum == 0x803F) return "DEC LAN Traffic Monitor";
  if (pnum>= 0x8040 && pnum <= 0x8042) return "DEC Unassigned";
  if (pnum == 0x8044) return "Planning Research Corp.";
  if (pnum == 0x8046) return "AT&T";
  if (pnum == 0x8047) return "AT&T";
  if (pnum == 0x8049) return "ExperData";
  if (pnum == 0x805B) return "Stanford V Kernel exp.";
  if (pnum == 0x805C) return "Stanford V Kernel prod.";
  if (pnum == 0x805D) return "Evans & Sutherland";
  if (pnum == 0x8060) return "Little Machines";
  if (pnum == 0x8062) return "Counterpoint Computers";
  if (pnum == 0x8065) return "Univ. of Mass. @ Amherst";
  if (pnum == 0x8066) return "Univ. of Mass. @ Amherst";
  if (pnum == 0x8067) return "Veeco Integrated Auto.";
  if (pnum == 0x8068) return "General Dynamics";
  if (pnum == 0x8069) return "AT&T";
  if (pnum == 0x806A) return "Autophon";
  if (pnum == 0x806C) return "ComDesign";
  if (pnum == 0x806D) return "Computgraphic Corp.";
  if (pnum>= 0x806E && pnum <= 0x8077) return "Landmark Graphics Corp.";
  if (pnum == 0x807A) return "Matra";
  if (pnum == 0x807B) return "Dansk Data Elektronik";
  if (pnum == 0x807C) return "Merit Internodal";
  if (pnum>= 0x807D && pnum <= 0x807F) return "Vitalink Communications";
  if (pnum == 0x8080) return "Vitalink TransLAN III";
  if (pnum>= 0x8081 && pnum <= 0x8083) return "Counterpoint Computers";
  if (pnum == 0x809B) return "Appletalk";
  if (pnum>= 0x809C && pnum <= 0x809E) return "Datability";
  if (pnum == 0x809F) return "Spider Systems Ltd.";
  if (pnum == 0x80A3) return "Nixdorf Computers";
  if (pnum>= 0x80A4 && pnum <= 0x80B3) return "Siemens Gammasonics Inc.";
  if (pnum>= 0x80C0 && pnum <= 0x80C3) return "DCA Data Exchange Cluster";
  if (pnum == 0x80C4) return "Banyan Systems";
  if (pnum == 0x80C5) return "Banyan Systems";
  if (pnum == 0x80C6) return "Pacer Software";
  if (pnum == 0x80C7) return "Applitek Corporation";
  if (pnum>= 0x80C8 && pnum <= 0x80CC) return "Intergraph Corporation";
  if (pnum>= 0x80CD && pnum <= 0x80CE) return "Harris Corporation";
  if (pnum>= 0x80CF && pnum <= 0x80D2) return "Taylor Instrument";
  if (pnum>= 0x80D3 && pnum <= 0x80D4) return "Rosemount Corporation";
  if (pnum == 0x80D5) return "IBM SNA Service on Ether";
  if (pnum == 0x80DD) return "Varian Associates";
  if (pnum>= 0x80DE && pnum <= 0x80DF) return "Integrated Solutions TRFS";
  if (pnum>= 0x80E0 && pnum <= 0x80E3) return "Allen-Bradley";
  if (pnum>= 0x80E4 && pnum <= 0x80F0) return "Datability";
  if (pnum == 0x80F2) return "Retix";
  if (pnum == 0x80F3) return "AppleTalk AARP (Kinetics)";
  if (pnum>= 0x80F4 && pnum <= 0x80F5) return "Kinetics";
  if (pnum == 0x80F7) return "Apollo Computer";
  if (pnum>= 0x80FF && pnum <= 0x8103) return "Wellfleet Communications";
  if (pnum>= 0x8107 && pnum <= 0x8109) return "Symbolics Private";
  if (pnum == 0x8130) return "Hayes Microcomputers";
  if (pnum == 0x8131) return "VG Laboratory Systems";
  if (pnum>= 0x8132 && pnum <= 0x8136) return "Bridge Communications";
  if (pnum>= 0x8137 && pnum <= 0x8138) return "Novell, Inc.";
  if (pnum>= 0x8139 && pnum <= 0x813D) return "KTI";
  if (pnum == 0x8148) return "Logicraft";
  if (pnum == 0x8149) return "Network Computing Devices";
  if (pnum == 0x814A) return "Alpha Micro";
  if (pnum == 0x814C) return "SNMP";
  if (pnum == 0x814D) return "BIIN";
  if (pnum == 0x814E) return "BIIN";
  if (pnum == 0x814F) return "Technically Elite Concept";
  if (pnum == 0x8150) return "Rational Corp";
  if (pnum>= 0x8151 && pnum <= 0x8153) return "Qualcomm";
  if (pnum>= 0x815C && pnum <= 0x815E) return "Computer Protocol Pty Ltd";
  if (pnum>= 0x8164 && pnum <= 0x8166) return "Charles River Data System";
  if (pnum>= 0x817D && pnum <= 0x818C) return "Protocol Engines";
  if (pnum == 0x818D) return "Motorola Computer";
  if (pnum>= 0x819A && pnum <= 0x81A3) return "Qualcomm";
  if (pnum == 0x81A4) return "ARAI Bunkichi";
  if (pnum>= 0x81A5 && pnum <= 0x81AE) return "RAD Network Devices";
  if (pnum>= 0x81B7 && pnum <= 0x81B9) return "Xyplex";
  if (pnum>= 0x81CC && pnum <= 0x81D5) return "Apricot Computers";
  if (pnum>= 0x81D6 && pnum <= 0x81DD) return "Artisoft";
  if (pnum>= 0x81E6 && pnum <= 0x81EF) return "Polygon";
  if (pnum>= 0x81F0 && pnum <= 0x81F2) return "Comsat Labs";
  if (pnum>= 0x81F3 && pnum <= 0x81F5) return "SAIC";
  if (pnum>= 0x81F6 && pnum <= 0x81F8) return "VG Analytical";
  if (pnum>= 0x8203 && pnum <= 0x8205) return "Quantum Software";
  if (pnum>= 0x8221 && pnum <= 0x8222) return "Ascom Banking Systems";
  if (pnum>= 0x823E && pnum <= 0x8240) return "Advanced Encryption Syste";
  if (pnum>= 0x827F && pnum <= 0x8282) return "Athena Programming";
  if (pnum>= 0x8263 && pnum <= 0x826A) return "Charles River Data System";
  if (pnum>= 0x829A && pnum <= 0x829B) return "Inst Ind Info Tech";
  if (pnum>= 0x829C && pnum <= 0x82AB) return "Taurus Controls";
  if (pnum>= 0x82AC && pnum <= 0x8693) return "Walker Richer & Quinn";
  if (pnum>= 0x8694 && pnum <= 0x869D) return "Idea Courier";
  if (pnum>= 0x869E && pnum <= 0x86A1) return "Computer Network Tech";
  if (pnum>= 0x86A3 && pnum <= 0x86AC) return "Gateway Communications";
  if (pnum == 0x86DB) return "SECTRA";
  if (pnum == 0x86DE) return "Delta Controls";
  if (pnum == 0x86DF) return "ATOMIC";
  if (pnum>= 0x86E0 && pnum <= 0x86EF) return "Landis & Gyr Powers";
  if (pnum>= 0x8700 && pnum <= 0x8710) return "Motorola";
  if (pnum == 0x876B) return "TCP/IP Compression";
  if (pnum == 0x876C) return "IP Autonomous Systems";
  if (pnum == 0x876D) return "Secure Data";
  if (pnum>= 0x8A96 && pnum <= 0x8A97) return "Invisible Software";
  if (pnum == 0x9000) return "Loopback";
  if (pnum == 0x9001) return "Com(Bridge) XNS Sys Mgmt";
  if (pnum == 0x9002) return "Com(Bridge) TCP-IP Sys";
  if (pnum == 0x9003) return "Com(Bridge) loop detect";
  if (pnum == 0xFF00) return "BBN VITAL-LanBridge cache";
  if (pnum>= 0xFF00 && pnum <= 0xFF0F) return "ISC Bunker Ramo";
  if (pnum == 0xFFFF) return "Reserved";
  fprintf(stderr,"Typ: 0x%4X\n",pnum);
  return "Unknown";
}

char* get_eth_prot(unsigned int prot) {
  switch (prot)  {
	case 0x0800: return "IP";
	case 0x0806: return "ARP";
	case 0x8035: return "RARP";
	case 0x8037:
	case 0x1237:
	case 0x1238:
	case 0x8137: return "IPX";
	case 0x4242: return "SPT";
	case 0x814C: return "SNMP";
	case 0x86DD: return "IPv6";
	case 0xF0F0: return "NetBIOS";
	case 0xAAAA: return "DECNet";
	default: return all_eth_types(prot);
  }
}

unsigned char xToi(char c){
  if(c>='a' && c<='f'){
    return ((c-'a')+10);
  }
  if(c>='A' && c<='F'){
    return ((c-'A')+10);
  }
  if(c>='0' && c<='9'){
    return (c-'0');
  }
  return FALSE;
}
  
int parseMacAddress(char *in, unsigned char *out){
  int i,j;
  for(i=0;in[i]!='\0';i++){
    if(!isxdigit(in[i])){
      return FALSE;
    }
  }
  if(i!=MAC_ADDR_LEN){
    return FALSE;
  }
  for(i=0,j=0;i<MAC_ADDR_LEN;i+=2,j++){
      out[j]=0;
      out[j]=((xToi(in[i])<<4)|(xToi(in[i+1])));
  }
  return TRUE;
}

int parseIpAddress(char *in, unsigned long *out){
  int i=0;
  int j=0;
  int b=0;
  *out=0;
  if(in[i]=='.') return FALSE;
  for(;in[i]!='\0';i++){
    if(in[i]>='0' && in[i] <= '9'){
      b*=10;
      b+=in[i]-'0';
      if(b>0xFF) return FALSE;
    }
    else if(in[i]=='.' && j<3 && in[i-1]!='.'){
      *out=(*out<<8)|(b&0xFF);
      b=0;
      j++;
    }
    else {
      return FALSE;
    }
  }
  if(j<3 || in[i-1] =='.') return FALSE;
  *out=(*out<<8)|(b&0xFF);
  *out=SWAP32(*out);
  return TRUE;
}


