#include "tcp_pkt.h"
const char * TCP_Pkt::Flg_n [] = { "FIN", "SYN", "RST", "PSH", "ACK", "URG"};

void TCP_Pkt::show(ushort flags) {
  if ( hdr && (flags & T_TCP)) {
    g_puts("TCP:");
    header(flags, FALSE);
    g_printf(" Delka: %lu (hl. %hu) Seq# 0x%0lX ",
	     siz, hdr->flg_off.fo.d_off << 2, hdr->seqNo);

    if ( hdr->flg_off.fo.flags & F_ACK) {
      g_printf("Ack# 0x%08lX ", hdr->ackNo);
    }

    if ( hdr->flg_off.fo.flags & F_URG) {
      g_printf("URG: 0x%04hX ", hdr->urgent_ptr);
    }
#if defined(__MSDOS__) && !defined(STDOUT)
    g_puts("\r\n     ");
#else
    g_puts("\n     ");
#endif
    if ( hdr->flg_off.fo.flags & ~(F_ACK | F_URG) ) {
      g_putc('<');
      for (uchar fl=1, i=0, fst=TRUE; i < FLG_LAST; i++, fl <<= 1) {
	if ( hdr->flg_off.fo.flags & fl ) {
	  if (fst) {
	    fst = FALSE;
	    g_printf("%s", Flg_n[i]);
	  } else {
	    g_printf(" %s", Flg_n[i]);
	  }
	}
      }
      g_puts("> ");
    }
    g_printf("Sirka okenka: %hu CHK: 0x%04hX", hdr->window, hdr->chksum);
    g_putc('\n');
  }
  if (next) {
    if ( !( flags & T_DATA) && (flags &  S_INTER) && hdr && 
         (inter_p(hdr->s_port, T_TCP, SRC) | 
          inter_p(hdr->d_port, T_TCP, DST)     ) == ALWAYS) {
       flags |= T_DATA;
    }
    next->show(flags);
  }
}
